package de.bb.util.test;
import java.util.Iterator;
import java.util.Map;

import de.bb.util.MultiMap;
import de.bb.util.SingleMap;
import junit.framework.TestCase;

public class TestMap extends TestCase {

  public void testMultiMap()
  {
    MultiMap multi = new MultiMap();

    for (int j = 0; j <= 10; j += 2)
    {
      for (int i = j; i <= 20; i += 2)
      {
        multi.put(new Integer(i), new Integer(i));
      }
    }

    int N = 0;
    for (Iterator i = multi.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(51, N);
  }

  
  public void testMultiHeadMap()
  {
    MultiMap multi = new MultiMap();

    for (int j = 0; j <= 10; j += 2)
    {
      for (int i = j; i <= 20; i += 2)
      {
        multi.put(new Integer(i), new Integer(i));
      }
    }

    int N = 0;
    Map map = multi.headMap(new Integer(11));
    for (Iterator i = map.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(21, N);
  }

  public void testMultiTailMap()
  {
    MultiMap multi = new MultiMap();

    for (int j = 0; j <= 10; j += 2)
    {
      for (int i = j; i <= 20; i += 2)
      {
        multi.put(new Integer(i), new Integer(i));
      }
    }

    int N = 0;
    Map map = multi.tailMap(new Integer(11));
    for (Iterator i = map.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(30, N);
  }
  
  public void testMultiSubMap()
  {
    MultiMap multi = new MultiMap();

    for (int j = 0; j <= 10; j += 2)
    {
      for (int i = j; i <= 20; i += 2)
      {
        multi.put(new Integer(i), new Integer(i));
      }
    }

    int N = 0;
    Map map = multi.subMap(new Integer(5), new Integer(15));
    for (Iterator i = map.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(27, N);
  }
  
  
  public void testSingleMap()
  {
    SingleMap single = new SingleMap();

    for (int i = 0; i <= 20; i += 2)
    {
      single.put(new Integer(i), new Integer(i));
    }

    int N = 0;
    for (Iterator i = single.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(11, N);
  }

  public void testSingleHeadMap()
  {
    SingleMap single = new SingleMap();

    for (int i = 0; i <= 20; i += 2)
    {
      single.put(new Integer(i), new Integer(i));
    }

    int N = 0;
    Map head = single.headMap(new Integer(11));
    for (Iterator i = head.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(6, N);
  }

  public void testSingleTailMap()
  {
    SingleMap single = new SingleMap();

    for (int i = 0; i <= 20; i += 2)
    {
      single.put(new Integer(i), new Integer(i));
    }

    int N = 0;
    Map head = single.tailMap(new Integer(9));
    for (Iterator i = head.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(6, N);
  }
  public void testSingleTailMapEmpty()
  {
    SingleMap single = new SingleMap();

    for (int i = 0; i <= 20; i += 2)
    {
      single.put(new Integer(i), new Integer(i));
    }

    int N = 0;
    Map head = single.tailMap(new Integer(21));
    for (Iterator i = head.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(0, N);
  }

  public void testSingleSubMap()
  {
    SingleMap single = new SingleMap();

    for (int i = 0; i <= 20; i += 2)
    {
      single.put(new Integer(i), new Integer(i));
    }

    int N = 0;
    Map head = single.subMap(new Integer(5), new Integer(15));
    for (Iterator i = head.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      Integer j = (Integer) e.getKey();
      assertEquals(j, e.getValue());
      ++N;
    }
    assertEquals(5, N);
  }

  public void testMultiMap_bug_1()
  {
    MultiMap multi = new MultiMap();
    multi.put("esp", "1");
    multi.put("ebp", "2");
    Map tail = multi.tailMap("0");
    int N = 0;
    for (Iterator i = tail.entrySet().iterator(); i.hasNext();)
    {
      Map.Entry e = (Map.Entry) i.next();
      e.getKey();
      ++N;
    }
    assertEquals(2, N);
  }
}
